; IdealWin - A Win32 program in Ideal mode.
; This example uses the include files that are in the Include directory of 
; Tasm IDE. 

ideal
p586
model flat,stdcall
locals

include "w32ideal.inc"

dataseg

s_msg           MSG <?>
s_wndclass      WNDCLASS <?>
hinstance       dd ?
hwnd            dd ?
classname       db "IDWIN", 0
windowtitle     db "IdealWin", 0
menutitle       db "IdealMenu", 0

codeseg

extrn Wnd_Proc:proc

;---- Program entry point (this is the start of WinMain)
start:
  ;---- Register window class
  call GetModuleHandle, 0
  mov [hinstance], eax
  mov [s_wndclass.style], CS_HREDRAW + CS_VREDRAW + CS_DBLCLKS
  mov [s_wndclass.lpfnWndProc], offset Wnd_Proc
  mov [s_wndclass.cbClsExtra], 0
  mov [s_wndclass.cbWndExtra], 0
  mov eax, [hinstance]
  mov [s_wndclass.hInstance], eax
  call LoadIcon, 0, IDI_APPLICATION
  mov [s_wndclass.hIcon], eax
  call LoadCursor, 0, IDC_ARROW
  mov [s_wndclass.hCursor], eax
  mov [s_wndclass.hbrBackground], COLOR_WINDOW +1
  mov [s_wndclass.lpszMenuName], offset menutitle
  mov [s_wndclass.lpszClassName], offset classname
  call RegisterClass, offset s_wndclass
  
  ;---- Create and show window
  call CreateWindowEx, 0, offset classname, offset windowtitle,\
        WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,\
        CW_USEDEFAULT, 0, 0, [hinstance], 0
  mov [hwnd], eax
  call ShowWindow, [hwnd], SW_SHOWNORMAL
  call UpdateWindow, [hwnd]

  ;---- Enter the messageloop
@@messageloop:
  call GetMessage, offset s_msg, 0, 0, 0
  cmp eax, 0
  je @@endloop
  call TranslateMessage, offset s_msg
  call DispatchMessage, offset s_msg
  jmp @@messageloop
@@endloop:
  call ExitProcess, [s_msg.wParam]
;---- End of program

end start
ends
